#include "Code11.h"

CMyWinApp MyApplication;

BOOL CMyWinApp::InitInstance()
{
    CCode11* pFrame = new CCode11;
    m_pMainWnd = pFrame;
    pFrame->ShowWindow(SW_SHOW);
    pFrame->UpdateWindow();
    return TRUE;
}

BEGIN_MESSAGE_MAP(CCode11,CFrameWnd)
	ON_WM_PAINT()
	ON_WM_LBUTTONDOWN()
    ON_BN_CLICKED(IDC_BUTTON,OnButton)
END_MESSAGE_MAP()

CCode11::CCode11()
{
	Create(NULL,"Code11: Partial Differential Equations",
		WS_OVERLAPPEDWINDOW,CRect(0,0,900,700),NULL);
	Arial80.CreatePointFont(80,"Arial");
	menu[0].hm=CPoint(10,300); hGrid=CPoint(150,285);
	menu[0].rc=CRect(menu[0].hm.x,menu[0].hm.y,
		menu[0].hm.x+139,menu[0].hm.y+500);
	menu[1].item="Poisson's Equation";
	menu[2].item="Heat Equation";
	menu[3].item="Wave Equation";
	for (int i=1;i<=nMenuItems;i++)
	{
		menu[i].hm=CPoint(20,30+(i-1)*30);
		menu[i].rc=CRect(menu[i].hm.x,menu[i].hm.y,
			menu[i].hm.x+150,menu[i].hm.y+20);
	}
	input[0].hm=CPoint(200,20);
	input[0].rc=CRect(input[0].hm.x,input[0].hm.y,
		input[0].hm.x+560,input[0].hm.y+220);
	for (i=1;i<=maxInput;i++)
		input[i].hm=CPoint(input[0].hm.x+10,input[0].hm.y+30+(i-1)*25);
	input[0].display=CRect(20,170,170,230);
	pt=new PT [M*N+1];
	fMenu=0; idc=301;
	fStatus=0; fMenu=0;
	wrc=CSize(50,30);
	hSpace=70; vSpace=50; r1vspace=40;
	rcGrid=CRect(hGrid.x-150,hGrid.y-30,hGrid.x+750,hGrid.y+500);
	a=new double *[M*N+1];
	b=new double [M*N+1];
	z=new double [M*N+1];
	u=new double *[N+1];
	w=new double *[N+1];
	for (int i=0;i<=N;i++)
	{
		u[i]=new double [M+1];
		w[i]=new double [M+1];
	}
	for (i=0;i<=M*N;i++)
		a[i]=new double [M*N+1];
}

CCode11::~CCode11()
{	
	for (int i=0;i<=N;i++)
		delete u[i],w[i];
	for (i=0;i<=M*N;i++)
		delete a[i];
	delete u,w,a,b,z,u,w,pt;
}

void CCode11::OnPaint()
{
	CPaintDC dc(this);
	CString str;
	CRect rc;
	int i,j,r;
	dc.SelectObject(Arial80);
	dc.SetBkColor(RGB(150,150,150));
	dc.SetTextColor(RGB(255,255,255));
	for (i=1;i<=nMenuItems;i++)
	{
		dc.FillSolidRect(&menu[i].rc,RGB(150,150,150));
		dc.TextOut(menu[i].hm.x+5,menu[i].hm.y+5,menu[i].item);
	}
	dc.SetBkColor(RGB(255,255,255));
	dc.SetTextColor(RGB(100,100,100));
	dc.Rectangle(input[0].rc);
	if (fMenu==1)
		str="u[xx] + u[yy]=0";
	if (fMenu==2)
		str="u[t] - alpha^2*u[xx]=0";
	if (fMenu==3)
		str.Format("u[tt] - alpha^2*u[xx]=0");
	dc.TextOut(input[0].hm.x+150,input[0].hm.y+5,menu[fMenu].item+": "+str);
	if (fMenu>=0)
		for (i=1;i<=nInputItems;i++)
			dc.TextOut(input[i].hm.x+10,input[i].hm.y,input[i].label);
	if (fStatus>=2)
	{
		for (j=m;j>=0;j--)
		{
			dc.MoveTo(hGrid.x+wrc.cx/2,hGrid.y+wrc.cy/2+j*vSpace);
			dc.LineTo(hGrid.x+wrc.cx/2+n*hSpace,hGrid.y+wrc.cy/2+j*vSpace);
		}
		for (i=0;i<=n;i++)
		{
			dc.MoveTo(hGrid.x+i*hSpace+wrc.cx/2,hGrid.y+wrc.cy/2);
			dc.LineTo(hGrid.x+i*hSpace+wrc.cx/2,hGrid.y+wrc.cy/2+m*vSpace);
		}
		dc.TextOut(hGrid.x-100,hGrid.y+m/2*vSpace-20,
			((fMenu==1)?"u(x0,y)":"u(x0,t)"));
		dc.TextOut(hGrid.x+(n+1)*hSpace-10,hGrid.y+m/2*vSpace-20,
			((fMenu==1)?"u(xN,y)":"u(xN,t)"));
		dc.TextOut(hGrid.x+n/2*hSpace-40,250,
			((fMenu==1)?"u(x,ym)":""));
		if (fMenu==2 || fMenu==3)
		{
			dc.TextOut(hGrid.x,hGrid.y+(m+1)*vSpace-10,"u(x,t0)");
			if (fMenu==3)
				dc.TextOut(hGrid.x+200,hGrid.y+(m+1)*vSpace-10,"uD(x,t0)");
		}
		if (fMenu==1)
			dc.TextOut(hGrid.x+n/2*hSpace-40,hGrid.y+(m+1)*vSpace-10,"u(x,y0)");
		for (j=m;j>=0;j--)
			for (i=0;i<=n;i++)
			{
				rc=CRect(hGrid.x+i*hSpace,hGrid.y+j*vSpace,
					hGrid.x+i*hSpace+wrc.cx,hGrid.y+j*vSpace+wrc.cy);
				dc.Rectangle(rc);
				str.Format("%d,%d",i,m-j); 
				dc.TextOut(hGrid.x+wrc.cx/3+i*hSpace,hGrid.y+2+j*vSpace,str);
			}
	}
	if (fStatus==3)
	{
		for (j=m;j>=0;j--)
			for (i=0;i<=n;i++)
			{
				str.Format("%.4lf",u[i][j]);
				dc.TextOut(hGrid.x+i*hSpace+5,hGrid.y+15+(m-j)*vSpace,str);
			}
		if (fMenu==1)
		{
			dc.TextOut(30,180,"Poisson's Equation");
			dc.TextOut(30,195,"u[xx]+u[yy]="+input[1].item);
			dc.TextOut(30,210,input[4].item+"< x <"+input[5].item
						+", "+input[6].item+"< y <"+input[7].item);
		}
		if (fMenu==2)
		{
			str.Format("%lf",pow(alpha,2));
			dc.TextOut(30,180,"Heat Equation");
			dc.TextOut(30,195,"u[t]-"+str+" u[xx]=0");
			dc.TextOut(30,210,input[4].item+"< x <"+input[5].item
						+", "+input[6].item+"< t <"+input[7].item);
		}
		if (fMenu==3)
		{
			str.Format("%lf",pow(alpha,2));
			dc.TextOut(30,180,"Wave Equation");
			dc.TextOut(30,195,"u[tt]-"+str+" u[xx]=0");
			dc.TextOut(30,210,input[4].item+"< x <"+input[5].item
						+", "+input[6].item+"< t <"+input[7].item);
		}
	}
}

void CCode11::InputLabels()
{
	if (fMenu>0)
	{
		nInputItems=7;
		input[2].label="n (2-8)";
		input[3].label="m (2-8)";
		input[4].label="x[0]";
		input[5].label="x[n]";
	}
	if (fMenu==1)
	{
		input[1].label="w(x,y)";
		input[6].label="y[0]";
		input[7].label="y[m]";
	}
	if (fMenu==2 || fMenu==3)
	{
		input[1].label="alpha";
		input[6].label="t[0]";
		input[7].label="t[m]";
	}
}

void CCode11::OnLButtonDown(UINT nfStatuss,CPoint pt)
{
	int i,k;
	for (k=1;k<=nMenuItems;k++)
		if (menu[k].rc.PtInRect(pt))
		{
			fMenu=k; fStatus=1;
			for (i=1;i<=maxInput;i++)
				input[i].ed.DestroyWindow();
			table1.DestroyWindow();
			table2.DestroyWindow();
			Clear(input[0].display);
			Clear(rcGrid);
			InvalidateRect(input[0].rc);
			btn.DestroyWindow();
			btn.Create("Compute",WS_CHILD | WS_VISIBLE | BS_DEFPUSHBUTTON,
				CRect(50,140,150,170),this,IDC_BUTTON);
			for (int i=1;i<=maxInput-1;i++)
				input[i].ed.DestroyWindow();
			switch(k)
			{
				case 1: 
					fMenu=1; InputLabels(); break;
				case 2: 
					fMenu=2; InputLabels(); break;
				case 3: 
					fMenu=3; InputLabels(); break;
			}
			for (i=1;i<=nInputItems;i++)
				input[i].ed.Create(WS_CHILD | WS_VISIBLE | WS_BORDER, 
					CRect(input[i].hm.x+100,input[i].hm.y,input[i].hm.x+520,
					input[i].hm.y+20),this,idc++);
		}
}

void CCode11::OnButton()
{
	CRect rc;
	int i,j;
	if (fStatus==3)
		fStatus=2;
	if (fMenu==1)
	{
		if (fStatus==2)
			Poisson();
		if (fStatus==1)
		{
			for (i=1;i<=nInputItems;i++)
				input[i].ed.GetWindowText(input[i].item);
			n=atoi(input[2].item); n=((n<=N)?n:N);
			m=atoi(input[3].item); m=((m<=M)?m:M);
			pt[0].x=atof(input[4].item); 
			pt[n].x=atof(input[5].item);
			pt[0].y=atof(input[6].item); 
			pt[m].y=atof(input[7].item);
			h=(double)1/n*(pt[n].x-pt[0].x);
			k=(double)1/m*(pt[m].y-pt[0].y);
			input[nInputItems+1].ed.DestroyWindow();
			input[nInputItems+2].ed.DestroyWindow();
			input[nInputItems+1].ed.Create(WS_CHILD | WS_VISIBLE | WS_BORDER, 
					CRect(CPoint(hGrid.x-100,hGrid.y+m/2*vSpace),
					CSize(90,25)),this,idc++);
			input[nInputItems+2].ed.Create(WS_CHILD | WS_VISIBLE | WS_BORDER, 
					CRect(CPoint(hGrid.x+(n+1)*hSpace-10,hGrid.y+m/2*vSpace),
					CSize(90,25)),this,idc++);
			input[nInputItems+3].ed.DestroyWindow();
			input[nInputItems+4].ed.DestroyWindow();
			input[nInputItems+3].ed.Create(WS_CHILD | WS_VISIBLE | WS_BORDER, 
					CRect(CPoint(hGrid.x+n/2*hSpace,hGrid.y+(m+1)*vSpace-10),
					CSize(90,25)),this,idc++);
			input[nInputItems+4].ed.Create(WS_CHILD | WS_VISIBLE | WS_BORDER, 
					CRect(CPoint(hGrid.x+n/2*hSpace,250),
					CSize(90,25)),this,idc++);
			fStatus=2;
		}
	}
	if (fMenu==2)
	{
		if (fStatus==2)
			Heat();
		if (fStatus==1)
		{
			for (i=1;i<=nInputItems;i++)
				input[i].ed.GetWindowText(input[i].item);
			n=atoi(input[2].item); n=((n<=N)?n:N);
			m=atoi(input[3].item); m=((m<=M)?m:M);
			pt[0].x=atof(input[4].item); pt[n].x=atof(input[5].item);
			pt[0].t=atof(input[6].item); pt[m].t=atof(input[7].item);
			h=(double)1/n*(pt[n].x-pt[0].x);
			k=(double)1/m*(pt[m].t-pt[0].t);
			input[nInputItems+1].ed.DestroyWindow();
			input[nInputItems+2].ed.DestroyWindow();
			input[nInputItems+1].ed.Create(WS_CHILD | WS_VISIBLE | WS_BORDER, 
					CRect(CPoint(hGrid.x-100,hGrid.y+m/2*vSpace),
					CSize(90,25)),this,idc++);
			input[nInputItems+2].ed.Create(WS_CHILD | WS_VISIBLE | WS_BORDER, 
					CRect(CPoint(hGrid.x+(n+1)*hSpace-10,hGrid.y+m/2*vSpace),
					CSize(90,25)),this,idc++);
			input[nInputItems+3].ed.DestroyWindow();
			input[nInputItems+3].ed.Create(WS_CHILD | WS_VISIBLE | WS_BORDER, 
					CRect(CPoint(hGrid.x+n/2*hSpace,hGrid.y+(m+1)*vSpace-10),
					CSize(90,25)),this,idc++);
			fStatus=2;
		}
	}
	if (fMenu==3)
	{
		if (fStatus==2)
			Wave();
		if (fStatus==1)
		{
			for (i=1;i<=nInputItems;i++)
				input[i].ed.GetWindowText(input[i].item);
			n=atoi(input[2].item); n=((n<=N)?n:N);
			m=atoi(input[3].item); m=((m<=M)?m:M);
			pt[0].x=atof(input[4].item); pt[n].x=atof(input[5].item);
			pt[0].t=atof(input[6].item); pt[m].t=atof(input[7].item);
			h=(double)1/n*(pt[n].x-pt[0].x);
			k=(double)1/m*(pt[m].t-pt[0].t);
			input[nInputItems+1].ed.DestroyWindow();
			input[nInputItems+2].ed.DestroyWindow();
			input[nInputItems+1].ed.Create(WS_CHILD | WS_VISIBLE | WS_BORDER, 
					CRect(CPoint(hGrid.x-100,hGrid.y+m/2*vSpace),
					CSize(90,25)),this,idc++);
			input[nInputItems+2].ed.Create(WS_CHILD | WS_VISIBLE | WS_BORDER, 
					CRect(CPoint(hGrid.x+(n+1)*hSpace-10,hGrid.y+m/2*vSpace),
					CSize(90,25)),this,idc++);
			input[nInputItems+3].ed.DestroyWindow();
			input[nInputItems+4].ed.DestroyWindow();
			input[nInputItems+3].ed.Create(WS_CHILD | WS_VISIBLE | WS_BORDER, 
					CRect(CPoint(hGrid.x+40,hGrid.y+(m+1)*vSpace-10),
					CSize(90,25)),this,idc++);
			input[nInputItems+4].ed.Create(WS_CHILD | WS_VISIBLE | WS_BORDER, 
					CRect(CPoint(hGrid.x+240,hGrid.y+(m+1)*vSpace-10),
					CSize(90,25)),this,idc++);
			fStatus=2;
		}
	}
	rc=CRect(CPoint(hGrid.x+(n+1)*hSpace-10,hGrid.y+(m+1)*vSpace-10),CSize(100,25));
	InvalidateRect(rcGrid);
}

void CCode11::ShowTable()
{
	CString str;
	CPoint hTable;
	CRect rcTable;
	int sA,i,j;
	if (fMenu==1)
		sA=(m-1)*(n-1);
	if (fMenu==2)
		sA=m*(n-1);
	hTable=CPoint(200,20);
	rcTable=CRect(hTable.x,hTable.y,hTable.x+550,hTable.y+220);
	table1.DestroyWindow();
    table1.Create(WS_VISIBLE | WS_CHILD | WS_DLGFRAME | LVS_REPORT
        | LVS_NOSORTHEADER,rcTable,this,idc++);
	hTable=CPoint(770,20);
	rcTable=CRect(hTable.x,hTable.y,hTable.x+100,hTable.y+220);
	table2.DestroyWindow();
    table2.Create(WS_VISIBLE | WS_CHILD | WS_DLGFRAME | LVS_REPORT
        | LVS_NOSORTHEADER,rcTable,this,idc++);
	for (int i=1;i<=sA;i++)
		table1.InsertColumn(i-1,((i==1)?"A":""),LVCFMT_CENTER,80);
    table2.InsertColumn(0,"b",LVCFMT_CENTER,80);
	for (i=1;i<=sA;i++)
	{
		str.Format("%lf",a[1][i]); 
		table1.InsertItem(i-1,str,0);
		str.Format("%lf",b[i]); 
		table2.InsertItem(i-1,str,0);
		for (int j=1;j<=sA;j++)
		{
			str.Format("%lf",a[i][j]); 
			table1.SetItemText(i-1,j-1,str);
		}
	}
}

void CCode11::Poisson()
{
	int i,j,r,sA;
	int psi[4];
	double psv[4];
	SecondInput();
	pt[1].y=pt[0].y+k;
	for (j=1;j<=m-1;j++)
	{
		psi[1]=24; psv[1]=pt[j].y;
		u[0][j]=parse(input[nInputItems+1].item,1,psv,psi);
		u[n][j]=parse(input[nInputItems+2].item,1,psv,psi);
		pt[j+1].y=pt[j].y+k;
	}
	for (i=0;i<=n;i++)
	{
		psi[1]=23; psv[1]=pt[i].x;
		u[i][0]=parse(input[nInputItems+3].item,1,psv,psi);
		u[i][m]=parse(input[nInputItems+4].item,1,psv,psi);
		if (i<n)
			pt[i+1].x=pt[i].x+h;
	}
	for (j=0;j<=m;j++)
		for (i=0;i<=n;i++)
		{
			psi[1]=23; psv[1]=pt[i].x;
			psi[2]=24; psv[2]=pt[j].y;
			w[i][j]=parse(input[1].item,2,psv,psi);
		}
				
	// form the SLE
	sA=(m-1)*(n-1);
	for (i=1;i<=sA;i++)
	{
		b[i]=0;
		for (j=1;j<=sA;j++)
			a[i][j]=0;
	}
	for (r=1;r<=sA;r++)
	{
		a[r][r]=-2*(h*h+k*k);
		if (r<=2*(n-1))
		{
			a[r][n-1+r]=h*h;
			a[n-1+r][r]=h*h;
		}
		a[1][2]=k*k; a[2][1]=k*k;
		if (r%(n-1)!=0 && r<(m-1)*(n-1))
		{
			a[r][r+1]=k*k;
			a[r+1][r]=k*k;
		}
	}
	for (j=1;j<=m-1;j++)
		for (i=1;i<=n-1;i++)
		{
			// compute b[r]
			r=i+(j-1)*(n-1);
			b[r]=h*h*k*k*w[i][j];
			if (j==1)
			{
				b[r] -= h*h*u[i][0];
				if (i==1)
					b[r] -= k*k*u[0][1];
				if (i==n-1)
					b[r] -= k*k*u[n][1];
			}
			if (j>1 && j<m-1)
			{
				if (i==1)
					b[r] -= k*k*u[0][j];
				if (i==n-1)
					b[r] -= k*k*u[n][j];
			}
			if (j==m-1)
			{
				b[r] -= h*h*u[i][m];
				if (i==1)
					b[r] -= k*k*u[0][m-1];
				if (i==n-1)
					b[r] -= k*k*u[n][m-1];
			}
		}
	fStatus=3;
	Clear(input[0].rc);
	ShowTable();
	SolveSLE();
	InvalidateRect(rcGrid);
	InvalidateRect(input[0].display);
}

void CCode11::Clear(CRect rc)
{
	CClientDC dc(this);
	CBrush whiteBrush(RGB(255,255,255));
	dc.FillRect(&rc,&whiteBrush);
}

void CCode11::SolveSLE()
{
	int i,j,r,sA;
	double m1,Sum;

	if (fMenu==1)
		sA=(m-1)*(n-1);
	if (fMenu==2)
		sA=m*(n-1);

	// solve the SLE
	for (r=1;r<=sA-1;r++)
		for (i=r+1;i<=sA;i++)
		{
			m1=a[i][r]/a[r][r];
			for (j=1;j<=sA;j++)
				a[i][j] -= m1*a[r][j];
			b[i] -= m1*b[r];
		}
	for (r=sA;r>=1;r--)
	{
    	Sum=0;
		z[r]=0;
		for (j=r;j<=sA;j++)
       		Sum += a[r][j]*z[j];
		z[r]=(b[r]-Sum)/a[r][r];
	}
	for (j=1;j<=m;j++)
		for (i=1;i<=n-1;i++)
		{
			r=i+(j-1)*(n-1);
			if (fMenu==2)
				u[i][j]=z[r];
			if (fMenu==1 && j<=m-1)
				u[i][j]=z[r];
		}
}

void CCode11::Heat()
{
	int i,j,r,sA;
	int psi[4];
	double psv[4];
	SecondInput();
	alpha=atof(input[1].item);
	pt[1].t=pt[0].t+k;
	for (j=1;j<=m;j++)
	{
		psi[1]=19; psv[1]=pt[j].t;
		u[0][j]=parse(input[nInputItems+1].item,1,psv,psi);
		u[n][j]=parse(input[nInputItems+2].item,1,psv,psi);
		if (j<m)
			pt[j+1].t=pt[j].t+k;
	}
	for (i=0;i<=n;i++)
	{
		psi[1]=23; psv[1]=pt[i].x;
		u[i][0]=parse(input[nInputItems+3].item,1,psv,psi);
		if (i<n)
			pt[i+1].x=pt[i].x+h;
	}
	
	sA=m*(n-1);
	for (i=1;i<=sA;i++)
	{
		b[i]=0;
		for (j=1;j<=sA;j++)
			a[i][j]=0;
	}			
	for (j=0;j<=m-1;j++)
		for (i=1;i<=n-1;i++)
		{
			r=i+j*(n-1);
			// compute A
			a[r][r]=2*(h*h+alpha*alpha*k);
			if (r%(n-1)!=0 && r<m*(n-1))
			{
				a[r][r+1]=-alpha*alpha*k;
				a[r+1][r]=a[r][r+1];
			}
			if (r<=2*(n-1)+1)
				if (r%(n-1)!=1)
					a[n+r-2][r]=-alpha*alpha*k;
			if (r<=2*(n-1))
				a[n-1+r][r]=2*(-h*h+alpha*alpha*k);
			if (r<=2*(n-1)-1)
				if (r%(n-1)!=0)
					a[n+r][r]=-alpha*alpha*k;
				
			// compute b[r]
			if (j==0)
			{
				b[r]=pow(alpha,2)*k*u[i-1][0]-2*u[i][0]*(-pow(h,2)+k*pow(alpha,2))
					+pow(alpha,2)*k*u[i+1][0];
				if (i==1)
					b[r] += pow(alpha,2)*k*u[0][1];
				if (i==n-1)
					b[r] += pow(alpha,2)*k*u[n][1];
			}
			if (j>0)
			{
				if (i==1)
					b[r]=pow(alpha,2)*k*(u[0][j]+u[0][j+1]);
				if (i==n-1)
					b[r]=pow(alpha,2)*k*(u[n][j]+u[n][j+1]);
			}
		}
	fStatus=3;
	Clear(input[0].rc);
	ShowTable();
	SolveSLE();
	InvalidateRect(rcGrid);
	InvalidateRect(input[0].display);
}

void CCode11::Wave()
{
	int i,j,r,sA;
	int psi[2];
	double psv[2];
	double uD[N+1];
	SecondInput();
	alpha=atof(input[1].item);
	pt[1].t=pt[0].t+k; 
	psi[1]=19; 
	for (j=1;j<=m;j++)
	{
		psv[1]=pt[j].t;
		u[0][j]=parse(input[nInputItems+1].item,1,psv,psi);
		u[n][j]=parse(input[nInputItems+2].item,1,psv,psi);
		if (j<m)
			pt[j+1].t=pt[j].t+k;
	}
	psi[1]=23;
	for (i=0;i<=n;i++)
	{
		psv[1]=pt[i].x;
		u[i][0]=parse(input[nInputItems+3].item,1,psv,psi);
		uD[i]=parse(input[nInputItems+4].item,1,psv,psi);
		if (i<n)
			pt[i+1].x=pt[i].x+h;
	}
	for (i=1;i<=n-1;i++)
		u[i][1]=1/(2*pow(h,2))
				*(2*pow(h,2)*k*uD[i]+pow(k,2)*pow(alpha,2)*u[i-1][0]
				-(-2*pow(h,2)+2*pow(k,2)*pow(alpha,2))*u[i][0]
				+pow(k,2)*pow(alpha,2)*u[i+1][0]);
	for (j=1;j<=m-1;j++)
		for (i=1;i<=n-1;i++)
			u[i][j+1]=1/pow(h,2)*(-pow(h,2)*u[i][j-1]
					+pow(k,2)*pow(alpha,2)*u[i-1][j]
					-(-2*pow(h,2)+2*pow(k,2)*pow(alpha,2))*u[i][j]
					+pow(k,2)*pow(alpha,2)*u[i+1][j]);
	fStatus=3;
	InvalidateRect(rcGrid);
	InvalidateRect(input[0].display);
}

void CCode11::SecondInput()
{
	for (int i=1;i<=4;i++)
		if (fMenu!=2 || (fMenu==2 && i<4))
			input[nInputItems+i].ed.GetWindowText(input[nInputItems+i].item);
}