// Code2G.cpp: Complex number arithmetic
#include <iostream.h>
#include <math.h>

typedef struct
{
	double r;  			// real part
	double i;  			// imaginary part
} Complex;

class ComAlgebra
{
public:
	ComAlgebra( );
	Complex Add(Complex,Complex);
	Complex Subtract(Complex,Complex);
	Complex Conjugate(Complex);
	Complex Multiply(Complex,Complex);
	Complex Divide(Complex,Complex);
	Complex Inverse(Complex);
	double Magnitude(Complex);
	double Angle(Complex);
};

ComAlgebra::ComAlgebra( )
{ }

Complex ComAlgebra::Add(Complex u,Complex v)
{
	Complex w;
	w.r = u.r + v.r;
	w.i = u.i + v.i;
	return(w);
}

Complex ComAlgebra::Subtract(Complex u,Complex v)
{
	Complex w;
	w.r = u.r - v.r;
	w.i = u.i - v.i;
	return(w);
}

Complex ComAlgebra::Conjugate(Complex u)
{
	Complex w;
	w.r = u.r;
	w.i = -u.i;
	return(w);
}

Complex ComAlgebra::Multiply (Complex u, Complex v)
{
	Complex w;
	w.r = u.r*v.r - u.i*v.i;
	w.i = u.r*v.i + v.r*u.i;
	return(w);
}

Complex ComAlgebra::Divide(Complex u, Complex v)
{
	Complex c, w, s;
	double denominator;

	c = Conjugate(v);
	s = Multiply (u, c);
	denominator = v.r*v.r + v.i*v.i + 1.2e-60; 	//to prevent division by zero
	
	w.r = s.r/denominator;
	w.i = s.i/denominator;
	return(w);
}


Complex ComAlgebra::Inverse(Complex u)
{
	Complex w,v;
	v.r = 1.0;
	v.i = 0.0;
	w = Divide(v,u);
	return(w);
}

void main()
{
	Complex u,v,z,k;
	Complex p,q,r,s,c,d,e,f;
	ComAlgebra Compute;

	u.r=-4; u.i=7;
	v.r=6; v.i=3;

	k.r=2; k.i=0;
	p=Compute.Multiply(k,u);
	q=Compute.Inverse(v);
	r=Compute.Multiply(u,u);
	k.r=3; k.i=0;
	s=Compute.Multiply(k,u);

	c=Compute.Multiply(p,q);
	d=Compute.Multiply(r,v);
	e=Compute.Subtract(c,d);
	f=Compute.Add(s,v);
	z=Compute.Divide(e,f);

	cout << "z = " << z.r << " + " << z.i << "i" << endl;
}
