#include "Code3C.h"

CMyWinApp  MyApplication;

BOOL CMyWinApp::InitInstance()
{
    CCode3C* pFrame = new CCode3C;
    m_pMainWnd = pFrame;
    pFrame->ShowWindow(SW_SHOW);
    pFrame->UpdateWindow();
    return TRUE;
}

BEGIN_MESSAGE_MAP(CCode3C,CFrameWnd)
	ON_COMMAND(ID_FILEOPEN,OnFileOpen)
	ON_COMMAND(ID_FILESAVE,OnFileSave)
	ON_COMMAND(ID_GENERATE,OnGenerate)
	ON_COMMAND(ID_CLEAR,OnClear)
	ON_COMMAND(ID_EXIT,OnExit)
END_MESSAGE_MAP()

CCode3C::CCode3C()
{
	Create(NULL, "Code3C: File menus",
		WS_OVERLAPPEDWINDOW,CRect(0,0,600,400),
		NULL,MAKEINTRESOURCE(IDR_MENU1));
	pt=new CPoint [n+1];
}

CCode3C::~CCode3C()
{
	delete pt;
}

void CCode3C::OnClear()
{
	CClientDC dc(this);
	CRect rc;
	GetClientRect(&rc);
	CBrush whiteBrush(RGB(255,255,255));
	dc.FillRect(&rc,&whiteBrush);
	for (int i=1;i<=n;i++)
		pt[i]=CPoint(0,0);
}

void CCode3C::OnGenerate()
{
	CClientDC dc(this);
	CString str;
	time_t seed=time(NULL);	
	srand((unsigned)seed);
	OnClear();
	dc.TextOut(50,50,"Generating Random Numbers");
	for (int i=1;i<=n;i++)
	{
		pt[i].x=100+rand()%400; pt[i].y=50+rand()%300;
		str.Format("%d   %d",pt[i].x,pt[i].y);
		dc.TextOut(50,80+20*i,str);
	}
}

void CCode3C::OnFileOpen()
{
	CClientDC dc(this);
	CString str;
	CRect rc;
	FILE *ifp;
	char strFilter[] = {"TXT Files (*.txt)|*.txt|All Files (*.*)|*.*||"};
	CFileDialog FileDlg(TRUE,".txt",NULL,0,strFilter);
	if (FileDlg.DoModal()==IDOK)
	{
		str=FileDlg.GetFileName();
		ifp=fopen(str,"r");
		dc.TextOut(350,50,"File Opened: "+str);
		for (int i=1;i<=n;i++)
		{
			fscanf(ifp,"%d %d",&pt[i].x,&pt[i].y);
			rc=CRect(pt[i].x-30,pt[i].y-30,pt[i].x+30,pt[i].y+30);
			dc.Ellipse(rc);
			rc=CRect(pt[i].x-1,pt[i].y-1,pt[i].x+1,pt[i].y+1);
			dc.Rectangle(rc);
		}
		fclose(ifp);
	}
}

void CCode3C::OnFileSave()
{
	CClientDC dc(this);
	CString str;
	FILE *ofp;
	char strFilter[] = {"TXT Files (*.txt)|*.txt|All Files (*.*)|*.*||"};
	CFileDialog FileDlg(FALSE,".txt",NULL,0,strFilter);
	if( FileDlg.DoModal()==IDOK)
	{
		str=FileDlg.GetFileName();
		ofp=fopen(str,"w");
		dc.TextOut(50,20,"File Saved: "+str);
		str.Format("%d",n);
		dc.TextOut(50,50,"Contents: "+str+" randomly generated numbers");
		for (int i=1;i<=n;i++)
			fprintf(ofp,"%d  %d\n",pt[i].x,pt[i].y);
		fclose(ofp);
	}
}

void CCode3C::OnExit()
{
	CCode3C::OnExit();
}