#include "Code3D.h"

BOOL CMyWinApp::InitInstance()
{
	CMain* pFrame = new CMain;
	m_pMainWnd = pFrame;
	pFrame->ShowWindow(SW_SHOW);
	pFrame->UpdateWindow();
	return TRUE;
}
CMyWinApp  MyApplication;

BEGIN_MESSAGE_MAP(CMain, CFrameWnd)
	ON_WM_PAINT()
	ON_WM_KEYDOWN()
END_MESSAGE_MAP()

CMain::CMain()
{
	Create(NULL,"Code3D: Creativity with keyboard graphics",
		WS_OVERLAPPEDWINDOW,CRect(0,0,750,500));
	home=CPoint(40,40); end=CPoint(440,440);
	origin.x=(home.x+end.x)/2; origin.y=(home.y+end.y)/2;
	pt.x=origin.x; pt.y=origin.y; Increment=40;
	BgColor=RGB(255,255,255);
}

void CMain::OnPaint()
{
	CPaintDC dc(this);
	CString s;
	CRect rc;
	GetClientRect(&rc);
	CBrush blackBrush(BgColor);
	dc.FillRect(&rc,&blackBrush);

	CPen penGray(PS_SOLID,1,RGB(100,100,100));
	dc.SelectObject (penGray);
	for (int i=home.x;i<=end.x;i+=Increment)
		for (int j=home.y;j<=end.y;j+=Increment)
		{
			dc.MoveTo(i,j); dc.LineTo(400,j);
			dc.MoveTo(i,j);	dc.LineTo(i,400);
		}
	rc=CRect(CRect(origin.x-5,origin.y-5,origin.x+5,origin.y+5));
	dc.FillSolidRect(&rc,RGB(200,0,0));

	CFont fontCourier,fontTimesNR;
	dc.SetBkColor(BgColor);
	fontCourier.CreatePointFont (120,"Courier");
	dc.SelectObject (fontCourier);
	dc.SetTextColor(RGB(0,200,0));
	s.Format("%d,",pt.x); dc.TextOut(end.x+20,home.y,s);
	s.Format("%d",pt.y); dc.TextOut(end.x+60,home.y,s);

	fontTimesNR.CreatePointFont (120,"Times New Roman");
	dc.SelectObject (fontTimesNR);
	dc.SetTextColor(RGB(200,0,0));
	dc.TextOut(end.x+20,home.y+100,"Instructions:");
	dc.SetTextColor(RGB(0,100,200));
	dc.TextOut(end.x+Increment,home.y+125,"Spacebar to clear the screen");
	dc.TextOut(end.x+Increment,home.y+150,"left key to move left");
	dc.TextOut(end.x+Increment,home.y+175,"right key to move right");
	dc.TextOut(end.x+Increment,home.y+200,"up key to move up");
	dc.TextOut(end.x+Increment,home.y+225,"down key to move down");
}

void CMain::OnKeyDown(UINT MyKey,UINT nRep,UINT nFlags)
{
	CClientDC dc(this);
	CRect rc;
	CPen penBlue(PS_SOLID,3,RGB(0,00,200));
	CBrush whiteBrush(RGB(255,255,255));
	dc.SelectObject(&penBlue);

	rc=CRect(end.x+10,home.y-10,end.x+100,home.y+30);
	InvalidateRect(&rc);
	dc.MoveTo(pt.x,pt.y);
	switch(MyKey)
	{
		case VK_RIGHT:
			if (pt.x<end.x)
				pt.x += Increment;
			break;
		case VK_LEFT:
			if (pt.x>home.x)
				pt.x -= Increment;
			break;
		case VK_UP:
			if (pt.y>home.y)
				pt.y -= Increment;
			break;
		case VK_DOWN:
			if (pt.y<end.y)
				pt.y += Increment;
			break;
		case VK_SPACE:
		{
			pt.x=origin.x; pt.y=origin.y;
			Invalidate();
			break;
		}
	}
	dc.LineTo(pt.x,pt.y);
}
