// Code4B.cpp: drawing a curve
#include "Code4B.h"

CMyWinApp  MyApplication;

BOOL CMyWinApp::InitInstance()
{
    CCode4B* pFrame = new CCode4B;
    m_pMainWnd = pFrame;
    pFrame->ShowWindow(SW_SHOW);
    pFrame->UpdateWindow();
    return TRUE;
}

BEGIN_MESSAGE_MAP(CCode4B, CFrameWnd)
	ON_WM_PAINT()
END_MESSAGE_MAP()

CCode4B::CCode4B()
{
	Create(NULL, "Code4B: Drawing a Curve",
		WS_OVERLAPPEDWINDOW,CRect(0,0,700,430));
}

void CCode4B::OnPaint()
{
	typedef struct
	{
		double x,y;
	} PT;
	PT *pt,max,min,left,right;
	pt=new PT [m+1];
	CPaintDC dc(this);
	CString str;
	CPoint px,home,end;
	CFont fontTimes;
	double h,m1,m2,c1,c2;

	// draw the boundaries for the curve drawing area
	home=CPoint(30,30); end=CPoint(550,350);
	fontTimes.CreatePointFont(80,"Arial");
	dc.SelectObject(fontTimes);
	pt[0].x=-1; pt[m].x=1.8;
	h=(pt[m].x-pt[0].x)/(double)m;
	max.y=0; min.y=0;
	for (int i=0;i<=m;i++)
	{
		pt[i].y=2*pow(pt[i].x,4)+2*pow(pt[i].x,3)
			-9*pow(pt[i].x,2)-4*pt[i].x+1;
		if (max.y<pt[i].y)
			max=pt[i];
		if (min.y>pt[i].y)
			min=pt[i];
		if (i<m)
			pt[i+1].x=pt[i].x+h;
	}
	
	// Cartesian-Windows conversion parameters
	m1=(double)(end.x-home.x)/(pt[m].x-pt[0].x);
	c1=(double)home.x-pt[0].x*m1;
	m2=(double)(home.y-end.y)/(max.y-min.y);
	c2=(double)end.y-min.y*m2;

	// Draw the axes
	CPen pGray(PS_SOLID,1,RGB(200,200,200));
	dc.SelectObject(pGray);
	px=CPoint(m1*0+c1,m2*min.y+c2); dc.MoveTo(px);
	px=CPoint(m1*0+c1,m2*max.y+c2); dc.LineTo(px);
	px=CPoint(m1*pt[0].x+c1,m2*0+c2); dc.MoveTo(px);
	str.Format("%.0lf",pt[0].x); dc.TextOut(px.x,px.y,str);
	px=CPoint(m1*pt[m].x+c1,m2*0+c2); dc.LineTo(px);
	str.Format("%.1lf",pt[m].x); dc.TextOut(px.x,px.y,str);
		
	// draw the curve
	CPen pDark(PS_SOLID,2,RGB(50,50,50));
	dc.SelectObject(pDark);
	for (int i=0;i<=m;i++)
	{
		px=CPoint((int)(m1*pt[i].x+c1),(int)(m2*pt[i].y+c2));
		if (i==0)
		{
			dc.MoveTo(px);
			str.Format("(%.2lf,%.4lf)",pt[0].x,pt[0].y);
			dc.TextOut(px.x,px.y,str);
		}
		else
			dc.LineTo(px);
		if (pt[i].y==max.y)
		{
			str.Format("(%.2lf,%.4lf)",max.x,max.y);
			dc.TextOut(px.x,px.y-15,str);
		}
		if (pt[i].y==min.y)
		{
			str.Format("(%.2lf,%.4lf)",min.x,min.y);
			dc.TextOut(px.x,px.y,str);
		}
		if (i<m)
			pt[i+1].x=pt[i].x+h;
	}
	str.Format("(%.2lf,%.4lf)",pt[m].x,pt[m].y);
	dc.TextOut(px.x,px.y-15,str);
	dc.TextOut(100,350,"f(x)=2*x^4+2*x^3-9*x^2-4*x+1");
	delete pt;
}
