#include "Code4C.h"

CMyWinApp MyApplication;

BOOL CMyWinApp::InitInstance()
{
    CCode4C* pFrame = new CCode4C;
    m_pMainWnd = pFrame;
    pFrame->ShowWindow(SW_SHOW);
    pFrame->UpdateWindow();
    return TRUE;
}

BEGIN_MESSAGE_MAP(CCode4C,CFrameWnd)
	ON_WM_PAINT()
	ON_WM_LBUTTONDOWN()
END_MESSAGE_MAP()

CCode4C::CCode4C()
{
	int i;
	Create(NULL,"Code4C: Curve Drawing using MyParser",
		WS_OVERLAPPEDWINDOW,CRect(0,0,800,640),NULL);
	pt=new PT [m+1];
	fMenu=0; idc=301;
	menu[1].item="y=f(x)"; 
	menu[2].item="Parametric";
	curve.hm=CPoint(50,150); 
	curve.end=CPoint(750,560);
	curve.rc=CRect(curve.hm.x,curve.hm.y,curve.end.x,curve.end.y);
	input[1].hm=CPoint(240,20);
	input[2].hm=CPoint(660,20); 
	input[3].hm=input[2].hm+CPoint(60,0);
	input[4].hm=CPoint(660,70); 
	input[5].hm=input[4].hm+CPoint(60,0);
	input[6].hm=input[1].hm+CPoint(0,50); 
	input[7].hm=input[6].hm+CPoint(0,30);
	output[1].hm=CPoint(170,580); 
	output[2].hm=output[1].hm+CPoint(280,0);
	for (i=1;i<=nMenuItems;i++)
	{
		menu[i].hm=CPoint(20,20+(i-1)*50);
		menu[i].rc=CRect(menu[i].hm.x,menu[i].hm.y,
			menu[i].hm.x+150,menu[i].hm.y+30);
	}
	for (i=1;i<=nOutput;i++)
		output[i].st.Create("",WS_CHILD| WS_VISIBLE| SS_CENTER| WS_BORDER, 
			CRect(output[i].hm.x,output[i].hm.y,output[i].hm.x+150,
			output[i].hm.y+20),this,idc++);
	for (i=1;i<=nInput;i++)
		input[i].ed.Create(WS_CHILD | WS_VISIBLE | WS_BORDER, 
			CRect(input[i].hm.x,input[i].hm.y,input[i].hm.x
			+((i>1 && i<6)?35:250),input[i].hm.y+20),this,idc++);
	Arial80.CreatePointFont (80,"Arial");
}

CCode4C::~CCode4C()
{
	delete pt;
}

void CCode4C::OnPaint()
{
	CPaintDC dc(this);
	CString str;
	dc.SetBkColor(RGB(150,150,150));
	dc.SetTextColor(RGB(255,255,255));
	dc.SelectObject(Arial80);
	for (int i=1;i<=2;i++)
	{
		dc.FillSolidRect(&menu[i].rc,RGB(150,150,150));
		dc.TextOut(menu[i].hm.x+5,menu[i].hm.y+5,menu[i].item);
	}
	CRect rc=CRect(curve.hm.x-10,curve.hm.y-10,curve.end.x+10,curve.end.y+10);
	dc.Rectangle(rc);
	dc.SetBkColor(RGB(255,255,255));
	dc.SetTextColor(RGB(100,100,100));
	dc.TextOut(input[1].hm.x-30,input[1].hm.y,"f(x)");
	dc.TextOut(input[2].hm.x-90,input[2].hm.y,"Interval of x:");
	dc.TextOut(input[3].hm.x-20,input[3].hm.y,"to");
	dc.TextOut(input[4].hm.x-90,input[4].hm.y,"Interval of t:");
	dc.TextOut(input[5].hm.x-20,input[5].hm.y,"to");
	dc.TextOut(input[6].hm.x-30,input[6].hm.y,"f(t)");
	dc.TextOut(input[7].hm.x-30,input[7].hm.y,"g(t)");
	dc.TextOut(output[1].hm.x-40,output[1].hm.y,"Min");
	dc.TextOut(output[2].hm.x-40,output[2].hm.y,"Max");
	if (fMenu==1 || fMenu==2)
		DrawCurve();
}

void CCode4C::DrawCurve()
{
	CClientDC dc(this);
	int i,psi[2];
	double h,psv[2];
	double m1,m2,c1,c2;
	CString str;
	CPoint px;
	if (fMenu==1)
	{
		h=(pt[m].x-pt[0].x)/((double)(m));
		for (i=0;i<=m;i++)
		{
			psi[1]=23; psv[1]=pt[i].x;
			pt[i].y=parse(input[1].item,1,psv,psi);
			if (i==0)
			{
				left.x=0; right.x=0;
				min=pt[0]; max=pt[0];
			}
			left.x=((left.x>pt[i].x)?pt[i].x:left.x);
			right.x=((right.x<pt[i].x)?pt[i].x:right.x);
			if (min.y>pt[i].y)
			{
                min.x=pt[i].x; min.y=pt[i].y;
			}
			if (max.y<pt[i].y)
			{
                max.x=pt[i].x; max.y=pt[i].y;
			}
			if (i<m)
				pt[i+1].x=pt[i].x+h;
		}
	}
	if (fMenu==2)
	{
		h=(pt[m].t-pt[0].t)/((double)(m));
		for (int i=0;i<=m;i++)
		{
			psi[1]=19; psv[1]=pt[i].t;
			pt[i].x=parse(input[6].item,1,psv,psi);
			psi[1]=23; psv[1]=pt[i].x;
			pt[i].y=parse(input[7].item,1,psv,psi);
			if (i==0)
			{
				left.x=0; right.x=0;
				min=pt[0]; max=pt[0];
			}
			left.x=((left.x>pt[i].x)?pt[i].x:left.x);
			right.x=((right.x<pt[i].x)?pt[i].x:right.x);
			if (min.y>pt[i].y)
			{
                min.x=pt[i].x; min.y=pt[i].y;
			}
			if (max.y<pt[i].y)
			{
                max.x=pt[i].x; max.y=pt[i].y;
			}
			if (i<m)
				pt[i+1].t=pt[i].t+h;
		}
	}
	str.Format("(%.2lf,%.3lf)",min.x,min.y);
	output[1].st.SetWindowText(str);
	str.Format("(%.2lf,%.3lf)",max.x,max.y);
	output[2].st.SetWindowText(str);

	// Cartesian-Windows conversion coordinates
	m1=(double)(curve.end.x-curve.hm.x)/(right.x-left.x);
	c1=(double)curve.hm.x-left.x*m1;
	m2=(double)(curve.hm.y-curve.end.y)/(max.y-min.y);
	c2=(double)curve.end.y-min.y*m2;

	// Draw & label the x,y axis
	CPen pGray(PS_SOLID,1,RGB(200,200,200));
	dc.SelectObject(pGray);
	dc.SelectObject(Arial80);
	px=CPoint(m1*0+c1,m2*min.y+c2); dc.MoveTo(px);
	px=CPoint(m1*0+c1,m2*max.y+c2); dc.LineTo(px);
	
	px=CPoint(m1*left.x+c1,m2*0+c2); dc.MoveTo(px);
	str.Format("%.0lf",left.x); dc.TextOut(px.x,px.y,str);
	px=CPoint(m1*right.x+c1,m2*0+c2); dc.LineTo(px);
	str.Format("%.0lf",right.x); dc.TextOut(px.x-10,px.y,str);

	// draw the curve
	CPen pDark(PS_SOLID,2,RGB(50,50,50));
	dc.SelectObject(pDark);
	for (i=0;i<=m;i++)
	{
		px=CPoint((int)(m1*pt[i].x+c1),(int)(m2*pt[i].y+c2));
		if (i==0)
			dc.MoveTo(px);
		else
			dc.LineTo(px);
	}
}

void CCode4C::OnLButtonDown(UINT nFlags,CPoint pxClick)
{
	input[1].ed.GetWindowText(input[1].item);
	input[2].ed.GetWindowText(input[2].item); 
	input[3].ed.GetWindowText(input[3].item); 
	input[4].ed.GetWindowText(input[4].item); 
	input[5].ed.GetWindowText(input[5].item); 
	input[6].ed.GetWindowText(input[6].item); 
	input[7].ed.GetWindowText(input[7].item);
	pt[0].x=atof(input[2].item);
	pt[m].x=atof(input[3].item);
	pt[0].t=atof(input[4].item);
	pt[m].t=atof(input[5].item);
	if (menu[1].rc.PtInRect(pxClick))
		fMenu=1;
	if (menu[2].rc.PtInRect(pxClick))
		fMenu=2;
	InvalidateRect(curve.rc);
}
